<template lang="pug">
.field.is-grouped
	.control.is-expanded
		.field
			label.label.on-border
				span {{$t("form.name")}}&nbsp;
				span.has-text-danger *
			.control
				b-input( v-model='name' @input='handleNameInput' )
	.control.is-expanded
		.field.has-addons
			.control
				span.button.is-static dcr-motors.com/{{ brand ? `${brand.slug}/` : "" }}
			label.label.on-border
				span {{$t("form.link")}}&nbsp;
				span.has-text-danger *
			.control.has-icons-right.is-expanded(
				:class='checkProcessing || slugExist ? "has-icons-right" : ""')
				b-input( v-model='slug' @input='checkSlug' )
				p.help.has-text-danger( v-if='slugExist' ) {{ brand ? $t("form.car_exist") : $t("form.brand_exist") }}
				span.icon.is-small.is-right.has-text-black( v-if='checkProcessing' )
					i.fa-solid.fa-spinner.fa-pulse
				span.icon.is-small.is-right.has-text-danger( v-else-if='slugExist' )
					i.fa-solid.fa-circle-exclamation
</template>

<script setup>
	import BInput from "@/components/form/Input.vue"

	import slugify from "@/common/slugify"
	import debounce from "@/common/debounce"
	import { useBrandStore } from "@/stores/brand"
	import { useCarStore } from "@/stores/car"
	import { ref, computed, watch } from "vue"
	import { useRoute } from "vue-router"

	const props = defineProps({
		modelValue: Object,
		type: {
			type: String,
			default: "brand",
			validator: val => [ "brand", "car" ].includes(val)
		},
		brand: Object
	})
	const emit = defineEmits([ "update:modelValue" ])

	const cs = useCarStore()
	const bs = useBrandStore()
	const $route = useRoute()

	// Объявляем переменные названия и ссылки
	// Если значения переданы в modelValue, то присваиваем их, иначе пустая строка
	const name = ref(props.modelValue?.name || "")
	const slug = ref(props.modelValue?.slug || "")

	// Функция проверки уникальности ссылки
	const slugExist = ref(false)
	const checkProcessing = ref(false)
	const checkSlug = debounce(async v => {
		if (!slug.value) return

		let body = { slug: slug.value, exclude: $route.params.id }

		checkProcessing.value = true

		if (props.type == "brand") {
			slugExist.value = await bs.checkBrand(body)
		} else {
			body.brand = props.brand?.id
			slugExist.value = await cs.checkCar(body)
		}

		checkProcessing.value = false

		// Обновляем modelValue
		// Если ссылка существует, передаём пустое значение ссылки
		emit("update:modelValue", {
			...props.modelValue,
			name: name.value,
			slug: slugExist.value ? "" : v ? v : slug.value
		})
	}, 500)

	// Наблюдаем за изменениями ссылки
	// При каждом изменении, проверяем уникальность
	watch(() => slug.value, nv => checkSlug(nv))
	watch(() => ({ ...props.modelValue}), nv => {
		name.value = nv.name
		slug.value = nv.slug
	})

	// При изменении названия, трасформируем его в ссылку
	const handleNameInput = () => {
		if (props.modelValue?.year)
			slug.value = slugify(`${name.value}-${props.modelValue.year}`)
		else
			slug.value = slugify(name.value)
	}
</script>